// TCP/IP Stack Javascript Library. http://www.kernelchip.ru
var timeOutMS = 7000;
var ajaxList = new Array();

function newAJAXCommand(url, container, repeat, data) {	
var newAjax = new Object();
var theTimer = new Date();
newAjax.url = url;
newAjax.container = container;
newAjax.repeat = repeat;
newAjax.ajaxReq = null;		
	if(window.XMLHttpRequest) {
        newAjax.ajaxReq = new XMLHttpRequest();
        newAjax.ajaxReq.open((data==null)?"GET":"POST", newAjax.url, true);
        newAjax.ajaxReq.send(data); 
    } else if(window.ActiveXObject) {
        newAjax.ajaxReq = new ActiveXObject("Microsoft.XMLHTTP");
        if(newAjax.ajaxReq) {
            newAjax.ajaxReq.open((data==null)?"GET":"POST", newAjax.url, true);
            newAjax.ajaxReq.send(data);
        }
    }    
    newAjax.lastCalled = theTimer.getTime();   
    ajaxList.push(newAjax);
}

function pollAJAX() {	
	var curAjax = new Object();
	var theTimer = new Date();
	var elapsed;	
	for(i = ajaxList.length; i > 0; i--)	{
		curAjax = ajaxList.shift();
		if(!curAjax)
			continue;
		elapsed = theTimer.getTime() - curAjax.lastCalled;	
		if(curAjax.ajaxReq.readyState == 4 && curAjax.ajaxReq.status == 200) {			
		  if(typeof(curAjax.container) == 'function'){
		    if (curAjax.ajaxReq.responseXML) curAjax.container(curAjax.ajaxReq.responseXML.documentElement);
		    else if (curAjax.ajaxReq.response) curAjax.container(curAjax.ajaxReq.response);
		  } 
      else if(typeof(curAjax.container) == 'string') {
		    document.getElementById(curAjax.container).innerHTML = curAjax.ajaxReq.responseText;
		  } 			
	    	curAjax.ajaxReq.abort();
	    	curAjax.ajaxReq = null;			
			if(curAjax.repeat)
				newAJAXCommand(curAjax.url, curAjax.container, curAjax.repeat);
			continue;
		}			
		if(elapsed > timeOutMS) {			
			if(typeof(curAjax.container) == 'function'){
				curAjax.container(null);
			} else {}
	    	curAjax.ajaxReq.abort();
	    	curAjax.ajaxReq = null;						
			if(curAjax.repeat)
				newAJAXCommand(curAjax.url, curAjax.container, curAjax.repeat);
			continue;
		}		
		ajaxList.push(curAjax);
	}	
	setTimeout( "pollAJAX()", 100 );	
}			


function getXMLValue(xmlData, field) {
	try {
		if(xmlData.getElementsByTagName(field)[0].firstChild.nodeValue)
			return xmlData.getElementsByTagName(field)[0].firstChild.nodeValue;
		else return null;
	} catch(err) { return null; }
}
setTimeout("pollAJAX()", 500);



function toRusHex( str ) {
	var hex = '';
	for(var i = 0; i < str.length; i++) {      
    var _code = str.charCodeAt(i);
    if( _code >= 1040 && _code <= 1103 ) _code = _code - 1040 + 192;
    hex += ''+_code.toString(16);
	}
	return hex;
}

function hex2aRus(hexx) {
  var hex = hexx.toString();
  var str = '';
  for (var i = 0; (i < hex.length && hex.substr(i, 2) !== '00'); i += 2) {  
    var intH = parseInt( hex.substr(i, 2), 16); 
    if( intH >= 192 && intH <= 255 ) { 
      intH = intH - 192 + 1040;
    }       
    str += String.fromCharCode( intH );    
  }
  return str;
}


function hex2a(hexx) {
  var hex = hexx.toString();
  var str = '';
  for (var i = 0; (i < hex.length && hex.substr(i, 2) !== '00'); i += 2)
    str += String.fromCharCode(parseInt(hex.substr(i, 2), 16));
  return str;
}

function toHex(str) {
	var hex = '';
	for(var i=0;i<str.length;i++) {
		hex += ''+str.charCodeAt(i).toString(16);
	}
	return hex;
}

//
var JSN_BASIC_SET  = 0;
var JSN_SENSOR_VAL = 1;
var JSN_HW_SET     = 2;
var JSN_RT_STATUS  = 3;
var JSN_1W_BBU     = 4;
var JSN_1W_RAM     = 5;
var JSN_HW_NAMES   = 6;
var JSN_CAT_STAT   = 7;
var JSN_WEB_TERM   = 8;
var JSN_EVENTS     = 9;
var JSN_INC_CATX   = 10;
var JSN_INC_KESCR  = 11;
var JSN_INC_GSM_PHONES = 12;
var JSN_INC_RFID_BASE  = 13;
var JSN_TOTAL      = 14;


var JSN_TXT = [ 
"JSN_BASIC_SET",
"JSN_SENSOR_VAL",
"JSN_HW_SET",
"JSN_RT_STATUS",
"JSN_1W_BBU",
"JSN_1W_RAM",
"JSN_HW_NAMES",
"JSN_CAT_STAT",
"JSN_WEB_TERM",
"JSN_EVENTS",
"JSN_INC_CATX",
"JSN_INC_KESCR",
"JSN_INC_GSM_PHONES",
"JSN_INC_RFID_BASE",
"JSN_TOTAL"
];
 

// HW ids
var HW_ITEM_BEGGINING = 0;
var HW_ITEM_RELE_1    = 1;
var HW_ITEM_RELE_2    = 2;
var HW_ITEM_RELE_3    = 3;
var HW_ITEM_RELE_4    = 4;
var HW_ITEM_ISO_IN_1  = 5;
var HW_ITEM_ISO_IN_2  = 6;
var HW_ITEM_ISO_IN_3  = 7;
var HW_ITEM_ISO_IN_4  = 8;
var HW_ITEM_ISO_IN_5  = 9;
var HW_ITEM_ISO_IN_6  = 10;
var HW_ITEM_GPIO_1    = 11;
var HW_ITEM_GPIO_2    = 12;
var HW_ITEM_GPIO_3    = 13;
var HW_ITEM_GPIO_4    = 14;
var HW_ITEM_GPIO_5    = 15;
var HW_ITEM_GPIO_6    = 16;
var HW_ITEM_GPIO_7    = 17;
var HW_ITEM_GPIO_8    = 18;
var HW_ITEM_ISO_OUT_1 = 19;
var HW_ITEM_ISO_OUT_2 = 20;
var HW_ITEM_ISO_OUT_3 = 21;
var HW_ITEM_ISO_OUT_4 = 22;
var HW_ITEM_ISO_OUT_5 = 23;
var HW_ITEM_ADC_1     = 24;
var HW_ITEM_ADC_2     = 25;
var HW_ITEM_ADC_3     = 26;
var HW_ITEM_ADC_4     = 27;
var HW_ITEM_ADC_5     = 28;
var HW_ITEM_TOTAL     = 29;
  
var def_hw_names = new Array();
for (var i = 0; i <= HW_ITEM_TOTAL; i++) {
  def_hw_names[i] = "?";
}

def_hw_names[ HW_ITEM_BEGGINING ] = "-"; 
def_hw_names[ HW_ITEM_RELE_1    ] = "RELE_1"; 
def_hw_names[ HW_ITEM_RELE_2    ] = "RELE_2"; 
def_hw_names[ HW_ITEM_RELE_3    ] = "RELE_3"; 
def_hw_names[ HW_ITEM_RELE_4    ] = "RELE_4"; 
def_hw_names[ HW_ITEM_ISO_IN_1  ] = "IN_1"; 
def_hw_names[ HW_ITEM_ISO_IN_2  ] = "IN_2"; 
def_hw_names[ HW_ITEM_ISO_IN_3  ] = "IN_3"; 
def_hw_names[ HW_ITEM_ISO_IN_4  ] = "IN_4"; 
def_hw_names[ HW_ITEM_ISO_IN_5  ] = "IN_5"; 
def_hw_names[ HW_ITEM_ISO_IN_6  ] = "IN_6"; 
def_hw_names[ HW_ITEM_GPIO_1    ] = "IO_1"; 
def_hw_names[ HW_ITEM_GPIO_2    ] = "IO_2"; 
def_hw_names[ HW_ITEM_GPIO_3    ] = "IO_3"; 
def_hw_names[ HW_ITEM_GPIO_4    ] = "IO_4"; 
def_hw_names[ HW_ITEM_GPIO_5    ] = "IO_5"; 
def_hw_names[ HW_ITEM_GPIO_6    ] = "IO_6"; 
def_hw_names[ HW_ITEM_GPIO_7    ] = "IO_7"; 
def_hw_names[ HW_ITEM_GPIO_8    ] = "IO_8"; 
def_hw_names[ HW_ITEM_ISO_OUT_1 ] = "OUT_1"; 
def_hw_names[ HW_ITEM_ISO_OUT_2 ] = "OUT_2"; 
def_hw_names[ HW_ITEM_ISO_OUT_3 ] = "OUT_3"; 
def_hw_names[ HW_ITEM_ISO_OUT_4 ] = "OUT_4"; 
def_hw_names[ HW_ITEM_ISO_OUT_5 ] = "OUT_5"; 
def_hw_names[ HW_ITEM_ADC_1     ] = "ADC_1"; 
def_hw_names[ HW_ITEM_ADC_2     ] = "ADC_2"; 
def_hw_names[ HW_ITEM_ADC_3     ] = "ADC_3"; 
def_hw_names[ HW_ITEM_ADC_4     ] = "ADC_4"; 
def_hw_names[ HW_ITEM_ADC_5     ] = "ADC_5"; 
def_hw_names[ HW_ITEM_TOTAL     ] = "-";




var HW_MIN_RELE_ID = HW_ITEM_RELE_1;
var HW_MAX_RELE_ID = HW_ITEM_RELE_4;

var HW_MIN_ISO_IN_ID = HW_ITEM_ISO_IN_1;
var HW_MAX_ISO_IN_ID = HW_ITEM_ISO_IN_6;

var HW_MIN_ISO_OUT_ID = HW_ITEM_ISO_OUT_1;
var HW_MAX_ISO_OUT_ID = HW_ITEM_ISO_OUT_5;

var HW_MIN_GPIO_ID = HW_ITEM_GPIO_1;
var HW_MAX_GPIO_ID = HW_ITEM_GPIO_8;

var HW_MIN_ADC_ID = HW_ITEM_ADC_1;
var HW_MAX_ADC_ID = HW_ITEM_ADC_5;


var MODULE_UNKNOWN    = 0;
var MODULE_LAURENT_5  = 1;
var MODULE_LAURENT_5G = 2;
var MODULE_MODELS = [ "?", "Laurent-5", "Laurent-5G" ];

// HW limits
var ADC_CHAN_NUM    = 5;
var MAX_INPUT_LINE  = 9;
var IN_LINES_NUM    = 6;
var GPIO_LINES_NUM  = 8;
var OUT_LINES_NUM   = 5;
var RELE_NUM        = 4;
var TMPERATURE_NUM  = 20; 
var PWM_NUM         = 4; 
var ISO_IN_LINES    = 6;


var RFID_STORAGE_SIZE = 1000;
var RFID_MAX_NAME_LEN = 23;

function TMP_RAM_Object() {
  this.adr = new Array();
  for (var i = 0; i < 8; i++) {
    this.adr[i] = 0;
  }  
}

function TMP_BBU_Object() {
  this.adr = new Array();
  for (var i = 0; i < 8; i++) {
    this.adr[i] = 0;
  }
  this.name = "";  
}

function IMPL_Object() {  
  this.bEnabled = 0;
  this.eEvent   = 0;
  this.bSaveBBU = 0;      
  this.scal     = 1;
  this.eCntDir  = 0;
  this.cnt      = 0;  
}

var LCD_MAX_PAGES = 10;
function LCD_Object() {  
  this.bEnabled = -1;
  this.row  = -1;
  this.col  = -1;      
  this.page = -1;  
  this.cur_pageIdx = -1;
}

var _msg_txt = [ 
  "ECAT", 
  "EIN",
  "EIOI",
  "RFID",
  "IBUT",
  "DS18", 
  "ICAL",
  "ISMS",
  "TSMS",
  "DHCP",
  "TIME",
  "RELE",
  "IN",
  "IOD",
  "IOI",
  "IOO",
  "OUT",
  "ADCR",
  "ADCV",
  "PWM",
  "1WT",
  "HMD",
  "DHT",
  "IPLL",
  "IPLI",  
  "ACS",
  "GST"
];

var MSG_TYPE_EVENT  = 0;
var MSG_TYPE_ONTIME = 1;
  
var TOTAL_NUMBER_OF_MSG = _msg_txt.length;

function MSG_Object() {  
  this.name = "";
  this.mask = 0;  
}

function SAV_Object() {  
  this.bSAV = 0;
  this.sav_rel = 0;  
  this.sav_out = 0; 
  this.sav_gio = 0; 
  this.sav_pwm = 0; 
  this.per = 0;
}

// CATX
var CATX_ARRAY_SIZE      = 50;
var CATX_EVT_STRUCT_SIZE = 16;
var CATX_CMD_STRUCT_SIZE = 200;
var CATX_MAX_ADDON_NUM   = 5;

var CATX_TYPES = [
   "A",
   "B",
   "C",
   "D",
   "E", 
   "F",   
   "H",
   "I",
   "J",
   "K",
   "L",
   "M",
   "N",   
   "P",   
   "R", 
   "S", 
   "T", 
   "U",   
   "W",  
   "X",
   "Y",
   "s",
   "r",
   "d"   
];

var CATX_ADDON_TYPE_NONE   = 0;
var CATX_ADDON_TYPE_IN     = 1;
var CATX_ADDON_TYPE_IO_IN  = 2;
var CATX_ADDON_TYPE_IO_OUT = 3;
var CATX_ADDON_TYPE_OUT    = 4;
var CATX_ADDON_TYPE_RELE   = 5;
var CATX_ADDON_TYPE_CAT    = 6;
var CATX_ADDON_TYPE_VAR    = 7;

var TCP_SERVER_PORT = 0;     
var TCP_CLIENT_PORT = 1;        
var USART1_PORT     = 2;        
var WEB_PORT        = 3;         
var NULL_PORT       = 4;         
var URL_PORT        = 5;
var TOTAL_NUM_PORT  = 6;

var RFID_BASE_EVENT_NONE      = 0;
var RFID_BASE_EVENT_ADDED     = 1;        
var RFID_BASE_EVENT_DELETED   = 2;     
var RFID_BASE_EVENT_ALL_DEL   = 3;   
var RFID_BASE_EVENT_DUPLICATE = 4;
var RFID_BASE_EVENT_NOPLACE   = 5;
  
function CatX_AddON () {
  this.line = 0;
  this.type = 0;
  this.cond = 0;
  this.value = 0;
}

function CatcherXObject() {
  // Head
  this.eCatType     = 0;        
  this.bEnabled     = 0;        
  this.quote_cnt    = 0;   
  this.quote_time   = 0; 
  this.strat_delay  = 0;
      
  this.body = ""; 
  this.cmd  = "";
  
  this.addon = new Array();
  this.addon_hex = "";
  this.name = "";
    
  this.cnt = 0;
  
  // Update flags
  this._upd_body = 0;
  this._upd_reac = 0;
  this._upd_stat = 0;
}


function RFID_Element() {  
  this.type = 0;        
  this.name = "";
  this.id   = new Array();
  for( var kk = 0; kk < 8; kk++)   
    this.id[kk] = 0;
}

var NONE_CURRENT_TYPE = 0;
var AC_CURRENT_TYPE   = 1;
var DC_CURRENT_TYPE   = 2;

var A_SENSOR_UNKNOWN    = 0;
var A_SENSOR_ACS712_05A = 1;    
var A_SENSOR_ACS712_20A = 2;   
var A_SENSOR_ACS712_30A = 3;  


var ACS_MODES = [ "OFF", "AC", "DC" ];
var ACS_TYPES = [ "NOT_SET", "KACS-05", "KACS-20", "KACS-30" ];

function CurrSensor_Element() {  
  this.eConnected = 0;   
  this.eType   = 0;  
  this.offset  = 0;  
}

var USER_VARS_NUMBER = 10;

var OWI_BUS_NUMBER = 2; 
var OWI_BUS_A = 0;
var OWI_BUS_B = 1;

var OWI_FUNC_NONE    = 0;
var OWI_FUNC_DS18B20 = 1;     
var OWI_FUNC_DTH11   = 2;     
var OWI_FUNC_IBUTTON = 3;  
var OWI_FUNC_DTH22   = 4;  
  
function OWI_BUS_Object() {  
  this.mode    = 0;        
  this.dev_num = 0;  
  this.pwr     = true;
  this.rst_cnt = 0;
}

function WIEGAND_Object() {  
  this.enabled = 0;
  this.cnt     = 0;
  
  // Detected
  this.dect_id    = new Array(); 
  this.dect_id[0] = 0;
  this.dect_id[1] = 0;
  this.dect_id[2] = 0;
  this.dect_id[3] = 0;
  this.dect_id[4] = 0;
  this.dect_type  = 0;
  this.dect_white = 0;
}

var STATUS_OFF = 0;         
var STATUS_SETUP = 1;          
var STATUS_READY = 2;   

var ERR_NO_ERR = 0;                
var ERR_BAD_PIN_CODE = 1;       
var ERR_NO_SIM_CARD = 2;            
var ERR_INCORRECT_SIM_PIN = 3;      
var ERR_PUK_IS_ASKED = 4;          
var ERR_ASSERT_ALERT = 5;   

var GSM_PHONE_NUM      = 300;
var GSM_PHONE_STR_LEN  = 16; 
var GSM_PHONE_NAME_LEN = 32;

var GSM_INCAL_ALL_ANSWER   = 0;
var GSM_INCAL_ALL_DROP     = 1;
var GSM_INCAL_WHITE_ANSWER = 2;
var GSM_INCAL_TOTAL        = 3;

var GSM_INSMS_ALL_PROCESS   = 0;
var GSM_INSMS_ALL_DROP      = 1;
var GSM_INSMS_WHITE_PROCESS = 2;
var GSM_INSMS_TOTAL         = 3;

function PHN_Object() {  
  this.val = "";        
  this.nam = "";  
}

function GSM_Object() {
  this.mode = 0;
  this.pin = "";
  this.eGSM_Status = 0;
  this.eFATAL_TERMINATOR = 0;
  this.uiSMS_RCV = 0;          
  this.uiSMS_SNT = 0;            
  this.uiCAL_RCV = 0;            
  this.uiCAL_SNT = 0;  
  this.uiRSSI = 0;  

  this.phn = new Array(); 
  for(var i = 0; i < GSM_PHONE_NUM; i++ ) {
    this.phn[i] = new PHN_Object();
    this.phn[i].val = "";
    this.phn[i].nam = "";
  }  
  
  this.ical = 0;    
  this.isms = 0;  
  
  this.in_sms_phn = "";
  this.in_cal_phn = "";
  this.in_sms_cnt = 0;
  this.in_cal_cnt = 0;
}

function MDBS_Object() {  
  this.state = 0;
  this.port  = 0;  
}

var MAX_NUMBER_OF_SCR = 10;
function ScrObject() {     
  this.stat = 0;
  this.loop = 0;
  this.cnt  = 0;
  this.cmd  = "";
  
  // Update flags  
  this._upd_reac = 0;
  this._upd_stat = 0;
}

function DHT_MUL_Object() {  
  this.bConnected = 0;
  this.bValid = 0; 
  this.hum = 0;
  this.tmp = 0;  
}

function JSN_TAB_Object() {  
  this._perv = -2;        
  this._new  = -1;
}

//
function LaurentObject() {
  
  this.Connected  = 0;      
  this.time      =  0;
  this.sn        = "";
  this.fw        = "";  
  this.hw        = MODULE_UNKNOWN;

  this.pwm       = -1; 
  this.temp      = 0;  
   
  this.pass = "";
  this.ip   = "";
  this.mac  = "";
  this.mask = "";
  this.gate = "";  
  this.nbn  = "";
  this.dhcp = 0;
  
  this.security = 0;
  this.psw_need = 0;   
  
  
  this.jsn_tab = new Array();
  for (var i = 0; i < JSN_TOTAL; i++) {
    this.jsn_tab[i] = new JSN_TAB_Object();
    this.jsn_tab[i]._perv = -1;
    this.jsn_tab[i]._new  = -1;
  }

  
  this.dzg_in = new Array();
  for(var i = 0; i < IN_LINES_NUM; i++ ) {
    this.dzg_in[i] = 4; // 4 x 25 = 100 ms
  }  
  this.dzg_io = new Array();
  for(var i = 0; i < GPIO_LINES_NUM; i++ ) {
    this.dzg_io[i] = 4;
  }  
  
  this._time_Y  = 0;
  this._time_M  = 0;
  this._time_D  = 0;
  this._time_DW = 0;  
  this._time_h  = 0;
  this._time_m  = 0;
  this._time_s  = 0;
  
  this.tcp_port  = new Array();  
  for (i = 0; i < 3; i++) this.tcp_port[i] = 0;    
  
  this.adc_raw   = new Array();
  this.adc_fl    = new Array();
  this.adc_coef  = new Array();
  for (i = 0; i < ADC_CHAN_NUM; i++) {
    this.adc_raw[i]  = 0; 
    this.adc_fl[i]   = 0; 
    this.adc_coef[i] = 1.0;  
  }
    
  this.iso_in = new Array();
  for(i = 0; i < IN_LINES_NUM; i++ ) {
    this.iso_in[i] = 0;
  }
  
  this.gpio_in = new Array();
  for(i = 0; i < GPIO_LINES_NUM; i++ ) {
    this.gpio_in[i] = 0;
  }
  
  this.gpio_out = new Array();
  for(i = 0; i < GPIO_LINES_NUM; i++ ) {
    this.gpio_out[i] = 0;
  }
  
  this.gpio_dir = new Array();
  for(i = 0; i < GPIO_LINES_NUM; i++ ) {
    this.gpio_dir[i] = 0;
  }
  
  this.iso_out = new Array();
  for(i = 0; i < OUT_LINES_NUM; i++ ) {
    this.iso_out[i] = 0;
  }
   
  this.rele = new Array();    
  for(i = 0; i < RELE_NUM; i++)  {    
    this.rele[i] = 0;    
  }
    
  this.unm  = new Array();
  for(i = 0; i < HW_ITEM_TOTAL; i++)  {     
    this.unm[i] = def_hw_names[i];
  } 
  
  
  this.temp = new Array();  
  this.temp_ram = new Array();
  this.temp_bbu = new Array();
  this.temp_new = new Array();  
  this.bbu_new  = new Array();
  
  for (var i = 0; i < TMPERATURE_NUM; i++) {
    this.temp_ram[i] = new TMP_RAM_Object();
    this.temp_bbu[i] = new TMP_BBU_Object();
    this.temp_new[i] = 0;
    this.bbu_new[i]  = 0;
  }
  this.bTEMP_RAM_New  = 0;
  this.bTEMP_BBU_New  = 0;
  this.TEMP_RAM_Count = 0;
  this.TEMP_BBU_Count = 0;  
    
  // OWI  
  this.owi_bus = new Array();
  for( var i = 0; i < OWI_BUS_NUMBER; i++ ) {
    this.owi_bus[i] = new OWI_BUS_Object();
    
    if( i == OWI_BUS_A ) {    
      this.owi_bus[i].mode = OWI_FUNC_DS18B20;
      this.owi_bus[i].pwr  = true;
    }
    if( i == OWI_BUS_B ) {    
      this.owi_bus[i].mode = OWI_FUNC_DTH11;
      this.owi_bus[i].pwr  = true;
    }    
  }
    

  for (var i = 0; i < TMPERATURE_NUM; i++) this.temp[i] = 0;
      
      
  //this.tab_dat_falg = new Array();
  //for (var i = 0; i < TAB_DAT_TOTAL; i++) this.tab_dat_falg[i] = 0;  
   
  this.usart_baud_idx = 7;  // 115200 by def
  this.usart_mode     = 0;  // TCP-2-COM; CMD
  this.usart_dbit     = 8;
  this.usart_sbit     = 1;
  this.usart_parity   = 'n';
  this.usart1_tx = 0;        
  this.usart1_rx = 0;
  this.usart2_tx = 0;        
  this.usart2_rx = 0;
  
  // PWM 
  this.pwm_mask = new Array();
  this.pwm_val  = new Array();
  for (i = 0; i < PWM_NUM; i++) {
    this.pwm_mask[i] = 0; 
    this.pwm_val[i]  = 0;
  }
  this.pwm_frq = 0;
  
  // Wiegand
  this.wgn = new WIEGAND_Object();
  
  // Back TCPC
  this.btcpc_ip    = "";
  this.btcpc_port  = 0;
  this.btcpc_enab  = 0;
  this.btcpc_state = 0;
  this.btcpc_err   = 0;
  this.btcpc_tx    = 0;
  this.btcpc_rx    = 0;  
  
  // WEB CDM
  this.web_cmd_fback = "";
  
  // CAT
  this.catx = new Array();
  for( i = 0; i < CATX_ARRAY_SIZE; i++) {
    this.catx[i] = new CatcherXObject();
    
    for(var m = 0; m < CATX_MAX_ADDON_NUM; m++) {
      this.catx[i].addon[m] = new CatX_AddON();
    }
  }
  
  // DTH11
  this.dth11_bConnected = 0;  
  this.dth11_bValid = 0;     
  this.dth11_hum = 0;
  this.dth11_tmp = 0;
  
  
  // DTH11 Multi
  this.dth_mul = new Array();
  for(i = 0; i < GPIO_LINES_NUM; i++ ) {
    this.dth_mul[i] = 0;
  } 
  
  // LCD
  this.lcd = new LCD_Object();
   
  // Impl cnt
  this.impl_in = new Array();
  this.impl_io = new Array();
  
  for(i = 0; i < IN_LINES_NUM; i++ ) {
    this.impl_in[i] = new IMPL_Object();
  }
  
  for(i = 0; i < GPIO_LINES_NUM; i++ ) {
    this.impl_io[i] = new IMPL_Object();
  }
  
  // User variables
  this.user_var = new Array();
  for (i = 0; i < USER_VARS_NUMBER; i++) {
    this.user_var[i] = 0;
  }
  
  // RFID cards
  this.RFID_BaseMax   = 0;
  this.RFID_BaseTotal = 0;
  this.RFID_BaseEventType = 0;
  this.RFID_BaseEventCnt  = 0;
  this.rfid_base = new Array();
  for(var i = 0; i < RFID_STORAGE_SIZE; i++) {
    this.rfid_base[i] = new RFID_Element();
  }
  
  // MSG  
  this.msg_base = new Array();  
  for(i = 0; i < TOTAL_NUMBER_OF_MSG; i++) {
    this.msg_base[i] = new MSG_Object();
    
    this.msg_base[i].name = _msg_txt[i];
    this.msg_base[i].mask = 0;
  }
  
  // iBUT
  this.ibt_cnt = 0;
  this.ibt_white = 0;
  this.ibt_id = new Array(); 
  for( var i = 0; i < 8; i++) {
    this.ibt_id[i] = 0;
  }
  
  // SAV
  this.sav = new SAV_Object();
  
  this.web_source = 0;
  
  // Curr Sensor
  this.curr_sens_set = new Array();
  this.curr_sens_val = new Array();
  for(i = 0; i < ADC_CHAN_NUM; i++) {
    this.curr_sens_set[i] = new CurrSensor_Element();
	this.curr_sens_val[i] = 0;
  }
     
  // GSM_Object
  this.gsm = new GSM_Object(); 
  // ModbusTCP server
  this.mdbs = new MDBS_Object();
 
  // Ke-scr
  this.kescr = new Array();
  for( i = 0; i < MAX_NUMBER_OF_SCR; i++) {
    this.kescr[i] = new ScrObject();
  }
    
  this.IsConnected = function() { return this.Connected; }
  this.GetTime = function() { return this.time; }   
  this.GetFW   = function() { return this.fw; }    
  this.GetPass = function() { return this.pass; }
  this.GetIP   = function() { return this.ip; }
  this.GetMAC  = function() { return this.mac; } 
  this.GetMask = function() { return this.mask; } 
  this.GetGate = function() { return this.gate; }  
  
  
  var srv = "server.cgi?data";
  
  this.Ready = function() {     
    newAJAXCommand(srv+'=WEB,RFR'); 
  }  
  
  this.SetPass = function(value) {  
    newAJAXCommand(srv+'=PSW,NEW,' + value);
  }

  this.SetIP = function(value) { 
    newAJAXCommand(srv+'=IP,SET,' + value);
  }

  this.SetMAC = function(value) { 
    newAJAXCommand(srv+'=MAC,SET,' + value);
  }
  
  this.SetMSK = function(value) { 
    newAJAXCommand(srv+'=MSK,SET,' + value);
  }
  
  this.SetGTW = function(value) { 
    newAJAXCommand(srv+'=GTW,SET,' + value);
  }
  this.Set_DHCP  = function(value) { 
    newAJAXCommand(srv+'=DHCP,SET,' + value);
  }
  this.SetNBN = function(value) { 
    newAJAXCommand(srv+'=NBN,SET,' + value);
  }

  this.Reset = function() {
    newAJAXCommand(srv+'=RST');
  }

  this.Default = function() {
    newAJAXCommand(srv+'=DEFAULT');
  }   
  
  this.SetTCP_Port = function( port, val ) { 
    newAJAXCommand( srv + '=PRT,' + port + ",SET," + val ); 
  }
      
  this.SetPC_RTC = function( val ) { 
    newAJAXCommand( srv + '=RTC,SET,' + val ); 
  }      
      
  this.SetRele = function(ReleIdx) {     
    newAJAXCommand( srv + '=REL,' + ReleIdx + ',2' ); 
  }
  
  this.SetOut = function( Idx ) { 
    newAJAXCommand( srv + '=WR,' + Idx + ',2' ); 
  }
  
  this.Change_IO_DIR = function(Idx) { 
    newAJAXCommand( srv + '=IOD,SET,' + Idx + ',2' ); 
  }
  
  this.SetGPIO_Out = function(Idx) { 
    newAJAXCommand( srv + '=IOW,' + Idx + ',2' ); 
  }  
     
  this.Set_HW_Name = function( idx, str ) {         
    newAJAXCommand(srv+'=UNM,' + idx + ',H,SET,' + toRusHex(str) );
  } 
  
  this.UpdateDZG = function( _eType, _id, _val ) { 
    newAJAXCommand( srv + '=DZG,SET,' + _eType + ',' + _id + ',' + _val ); 
  }  
  
  this.SetSEC = function( val ) {     
    newAJAXCommand( srv + '=SEC,SET,' + val );
  }  
  
  this.SetKEVT = function( val ) { 
    newAJAXCommand( srv + '=EVT,SET,' + val );
  } 
  
  this.Set_ADC_Coef = function( idx, val ) {     
      newAJAXCommand(srv+'=ACF,' + idx + ',SET,' + val );
  }  
   
  this.SendUSART_HEX = function(value) {
    newAJAXCommand(srv+'=PUT,U,H,' + value );
  }
    
     
  this.ResetTxRx_CNT = function( ) { 
    newAJAXCommand( srv + '=USC,RST'  );
  }  
    
  this.Set_OWI_MOD = function( chan, val ) { 
    newAJAXCommand(srv+'=OWI,' + chan + ',MOD,SET,' + val );
  }
    
  this.SetBaud = function( val ) { 
    newAJAXCommand( srv + '=SPB,SET,' + val );
  }  
  
  this.SetUSART_Mode = function( val ) { 
    newAJAXCommand( srv + '=SER,MOD,SET,' + val );
  }  
  
  this.SetUSART_BITS  = function( dbits, sbits, parity ) { 
    newAJAXCommand( srv + '=SER,BITS,SET,' + dbits + ',' + sbits + ',' + parity );
  }  
    
  this.SendCMD = function( val ) { 
    newAJAXCommand( srv + '=CMD,' + val + '0D0A' );
  }  
  
  this.SendPWM_FRQ = function(value){
    newAJAXCommand(srv+'=PFR,SET,' + value );
  }
  
  this.SetPWM_MASK = function(_idx, _state){
    newAJAXCommand(srv+'=PSM,' + _idx + ',SET,' + _state );
  }
    
  this.SetPWM_Val = function (_idx, _val){
    newAJAXCommand(srv+'=PWM,' + _idx + ',SET,' + _val );
  }
  
  this.SetWGN = function( _state ) {
    newAJAXCommand(srv+'=WGN,SET,' + _state );
  }   
  
  this.TempSCAN = function () {
    newAJAXCommand(srv+'=TMP,SCAN');
  }
  
  this.TempDEL_BBU = function (_id) {    
    newAJAXCommand(srv+'=TMP,TAB,' + _id + ',DEL' );    
  }
  
  this.TempDEL_ALL_BBU = function () {
    newAJAXCommand(srv + '=TMP,TAB,DEL,ALL');
  }
  
  this.TempSAV_BBU = function (_adr_hex, name) {    
    newAJAXCommand(srv + '=TMP,TAB,-1,SET,' + _adr_hex + ',' + toRusHex( name ) );
  }  
  
  this.OWI_power = function (_bus, _state) {    
    newAJAXCommand(srv + '=OWI,' + _bus + ',PWR,SET,' + _state );
  }
  
    
  // GSM
  this.SetGSM_INIT = function(_state) {    
    newAJAXCommand(srv+'=GSM,INIT,SET,' + _state );
  } 
  this.SetNeedPIN = function( _state ) {
    newAJAXCommand(srv+'=PIN,NEED,SET,' + _state );
  }  
  this.SetGSM_PIN = function( _val ) {
    newAJAXCommand(srv+'=PIN,SET,' + _val );
  }
  this.SetGSM_PHN = function( _val ) {    
    newAJAXCommand(srv+'=PHN,1,H,SET,' + toHex(_val) );
  }
  
  // BTCPC
  this.SetBTCPC = function(_val) {
    newAJAXCommand(srv+'=BTCPC,SET,' + _val );
  }    
  this.SetBTCPC_IP = function(_val) {
    newAJAXCommand(srv+'=BTCPC,IP,SET,' + _val );
  }    
  this.SetBTCPC_PRT = function(_val) {
    newAJAXCommand(srv+'=BTCPC,PRT,SET,' + _val );
  }     
   
  // CATX  
  this.SetCAT_ALL_Action = function( action ) {      
    newAJAXCommand(srv+'=CAT,ALL,SET,' + action );
  }

  this.SetCAT_I_Action = function( idx, action ) { 
    if(action == 3 )  
      newAJAXCommand(srv+'=CAT,' + idx + ',SET,OPP' );
    else if(action == 2)  
      newAJAXCommand(srv+'=CAT,' + idx + ',DEL' );
    else if(action == 4)  
      newAJAXCommand(srv+'=CAC,' + idx + ',RST' );
  }
  this.SetCAT_DEL_ALL = function( ) { 
    newAJAXCommand(srv+'=CAT,ALL,DEL' );
  }

  this.SetCAT_New = function( idx, mes, _quot_cnt, _quot_time ) {    
       
    var _cmd1 = srv+'=CAT,' + idx + ',ADD,' + mes;
    var _cmd2 = srv+'=CAT,' + idx + ',QUOT,T,SET,' + _quot_time;
    var _cmd3 = srv+'=CAT,' + idx + ',QUOT,C,SET,' + _quot_cnt;
    
    setTimeout( newAJAXCommand, 5, _cmd1 );
    setTimeout( newAJAXCommand, 700, _cmd2 );
    setTimeout( newAJAXCommand, 1000, _cmd3 );
  }    
  
  this.SetCAT_ADNA = function( idx, _hex) {      
    var _cmd =  srv+'=CAT,' + idx + ',ADNA,' + _hex;
    setTimeout( newAJAXCommand, 1300, _cmd );
  }
  
  this.SetCAT_NAME = function( idx, __name ){
    var _cmd = srv+'=CAT,' + idx + ',NAME,SET,' + toRusHex( __name );
    setTimeout( newAJAXCommand, 1600, _cmd );
  }

  this.RequestCAT_Update = function() {
    newAJAXCommand( srv+'=CAT,ALL,UPD' );
  }
  this.RequestCAC_Reset = function() {
    newAJAXCommand( srv+'=CAC,ALL,RST' );
  }
    
  this.IMPL_Rst = function( _eType, _id ) {
    newAJAXCommand( srv+'=IPL,RST,' + _eType + ',' + _id );
  }
  
   this.IMPL_Enab = function( _eType, _id, _val ) {
    newAJAXCommand( srv+'=IPL,ENB,' + _eType + ',' + _id + ',SET,' + _val );
  }

  this.IMPL_Sav = function( _eType, _id, _val ) {
    newAJAXCommand( srv+'=IPL,MEM,' + _eType + ',' + _id + ',SET,' + _val );
  }
  
  this.IMPL_Type = function( _eType, _id, _val ) {
    newAJAXCommand( srv+'=IPL,EVT,' + _eType + ',' + _id + ',SET,' + _val );
  }
  
  this.IMPL_DIR = function( _eType, _id, _val ) {
    newAJAXCommand( srv+'=IPL,DIR,' + _eType + ',' + _id + ',SET,' + _val );
  }

  this.RFID_Base_Del = function( _id ) {
    newAJAXCommand( srv+'=RFD,' + _id + ',DEL' );
  }
  this.RFID_Update_Name = function(_id, _name) {
     var _cmd = srv+'=RFD,' + _id + ',NAME,H,SET,' + toRusHex( _name );
     newAJAXCommand( _cmd );
  }  
  
  this.RFID_Base_Del_All= function( ) {
    newAJAXCommand( srv+'=RFD,ALL,DEL' );
  }
  
  this.AddRFID_ToBase = function( hex_val ) {    
    newAJAXCommand( srv+'=RFD,-1,SET,H,' + hex_val );
  }
 
  this.MSG_Enab = function( port_char, _msg, state ) {    
    newAJAXCommand( srv+'=MSG,' + port_char + ',' + _msg + ',SET,' + state );
  }
  
  this.UpdateSAV_PER = function( _val ) {  
    newAJAXCommand( srv+'=SAV,PER,SET,' + _val );
  }  
  this.UpdateSAV_HW = function( _txt, state ) {  
    newAJAXCommand( srv+'=SAV,' + _txt + ',SET,' + state );
  } 
  this.UpdateSAV_CLN = function(  ) {  
    newAJAXCommand( srv+'=SAV,CLN' );
  }   
  this.SetWGN_Mode = function( value ) {  
    newAJAXCommand( srv+'=WGN,SET,' + value );
  } 
  this.Update_RFID_DelALL = function() {
    newAJAXCommand( srv+'=RFD,ALL,DEL' );
  }
  this.Set_WEB_SRC = function(value) {
    newAJAXCommand( srv+'=WEB,SRC,SET,' + value );
  }
  
  this.Set_ACS_MOD = function(idx, value) {
	var _id = idx + 1;
    newAJAXCommand( srv+'=ACS,' + _id + ',MOD,SET,' + ACS_MODES[value] );
  }
  this.Set_ACS_TYP = function(idx, value) {
    var _id = idx + 1;
    newAJAXCommand( srv+'=ACS,' + _id + ',TYP,SET,' + ACS_TYPES[value] );
  }
  this.Set_ACS_OFS = function(idx, value) {
    var _id = idx + 1;
    newAJAXCommand( srv+'=ACS,' + _id + ',OFS,SET,' + value );
  }
  
  this.Update_GsmReset = function() {
    newAJAXCommand( srv+'=GSM,RST' );
  }
  
  this.Set_GSM_GMD = function( value ) {
    newAJAXCommand( srv+'=GMD,SET,' + value );
  }
  
  this.SetGSM_PIN = function( value ) {
    newAJAXCommand( srv+'=PIN,SET,' + value );
  }
  
  this.Set_GSM_ICAL = function( value ) {
    newAJAXCommand( srv+'=GSM,ICAL,SET,' + value );
  }
  this.Set_GSM_ISMS = function( value ) {
    newAJAXCommand( srv+'=GSM,ISMS,SET,' + value );
  }  
  this.Set_GSM_DEL_ALL_PHN = function() {
    newAJAXCommand( srv+'=PHN,DEL,ALL' );
  }
  this.Set_GSM_ADD_PHN = function( slot, value, name ) {
    
    var _cmd1 = srv+'=PHN,' + slot + ',VAL,H,SET,' + value;
    var _cmd2 = srv+'=PHN,' + slot + ',NAM,H,SET,' + name;
        
    setTimeout( newAJAXCommand, 5, _cmd1 );
    setTimeout( newAJAXCommand, 500, _cmd2 );
  }  
  this.Set_GSM_Update_PHN_VAL = function( slot, value ) {
    newAJAXCommand(srv+'=PHN,' + slot + ',VAL,H,SET,' + value);
  }
  this.Set_GSM_Update_PHN_NAM = function( slot, name ) {
    newAJAXCommand(srv+'=PHN,' + slot + ',NAM,H,SET,' + name);
  }
  
  this.Set_GSM_DEL_PHN = function( value ) {
    newAJAXCommand( srv+'=PHN,' + value + ',DEL' );
  }  
  this.SetMBS_PRT = function( value ) {
    newAJAXCommand( srv+'=MBS,PRT,SET,' + value );
  }    
  this.SetMBS_Mode = function( value ) {
    newAJAXCommand( srv+'=MBS,SET,' + value );
  }  
  
  this.UpdateSCR = function( idx, value ) {
    newAJAXCommand( srv+'=SCR,' + idx + ',ADD,' + value );
  }  
  this.RunSCR = function( idx, value ) {
    newAJAXCommand( srv+'=SCR,' + idx + ',RUN,' + value );
  }  
  this.StopSCR = function( idx ) {
    newAJAXCommand( srv+'=SCR,' + idx + ',STOP' );
  } 
  this.DeleteSCR = function( idx ) {
    newAJAXCommand( srv+'=SCR,' + idx + ',DEL' );
  } 
  
  this.SetLCD_RowNum = function( value ) {    
    newAJAXCommand( srv+'=LCD,LINE,SET,' + value );
  }   
  this.SetLCD_CharNum = function( value ) {    
    newAJAXCommand( srv+'=LCD,CHAR,SET,' + value );
  }   
  this.SetLCD_PageNum = function( value ) {    
    newAJAXCommand( srv+'=LCD,PAGE,SET,' + value );
  }   
  this.SetLCD_PageNext = function() {    
    newAJAXCommand( srv+'=LCD,PG,NEXT' );
  } 
  this.SetLCD_PagePrev = function() {    
    newAJAXCommand( srv+'=LCD,PG,PREV' );
  } 
  this.LCD_WirePage = function( page, data ) {        
    newAJAXCommand( srv+'=LCD,WR,' + page + ',P,H,' + data );
  }  
  this.LCD_WireLine = function( page, line, data ) {        
    newAJAXCommand( srv+'=LCD,WR,' + page + ',L,H,' + line + ',' + data );
  }   
  this.LCD_ClnAll = function() {    
    newAJAXCommand( srv+'=LCD,CLN,ALL' );
  } 
  this.LCD_ClnCurPage = function(value) {    
    newAJAXCommand( srv+'=LCD,CLN,PG,' + value );
  } 
   
   
      
  this.UpdateStatus = function(xmlData){   
  if( !xmlData ) { this.Connected = 0; return; }  
  
  this.Connected = 1;
  var TempLoc;   

  TempLoc = getXMLValue( xmlData, 'systime0' );
  if( TempLoc ) {
    var str = TempLoc;
    var tagList = str.split(".");
    
    this.time     = parseInt(tagList[0]);
    this._time_h  = parseInt(tagList[1]);
    this._time_m  = parseInt(tagList[2]);
    this._time_s  = parseInt(tagList[3]);     
  }    

  TempLoc = getXMLValue( xmlData, 'jsn_tab0' );
  if( TempLoc ) {
    var str = TempLoc;
    var tagList = str.split(".");
	
    var _expected = parseInt(tagList[0]);
    if( _expected != JSN_TOTAL ) {
      alert("JSN_TOTAL!");
      return;
    }
	
    for( var m = 0; m < JSN_TOTAL; m++) {
      this.jsn_tab[m]._new  = parseInt(tagList[1 + m]);
    }
  } 
  
  }    
  this.Run = function(){
    setTimeout( "newAJAXCommand('status.xml', updateStatusLaurent, true)", 1000 );
  }
}

var bLaurentExists_XX = false;
var ObjLaurent_XX = null;

function GetLaurentObject() {
  if( !bLaurentExists_XX ) {
     ObjLaurent_XX = new LaurentObject();
     bLaurentExists_XX = true;
  }
  return ObjLaurent_XX;
}

function updateStatusLaurent( xmlData ) {
  ObjLaurent_XX.UpdateStatus( xmlData );   
}

function getCookie(name) {
  let matches = document.cookie.match(new RegExp(
    "(?:^|; )" + name.replace(/([\.$?*|{}\(\)\[\]\\\/\+^])/g, '\\$1') + "=([^;]*)"
  ));
  return matches ? decodeURIComponent(matches[1]) : undefined;
}

function setCookie(name, value, options = {}) {

  options = {
    path: '/',
	expires: 'Tue, 19 Jan 2038 03:14:07 GMT'
  };

  let updatedCookie = encodeURIComponent(name) + "=" + encodeURIComponent(value);

  for (let optionKey in options) {
    updatedCookie += "; " + optionKey;
    let optionValue = options[optionKey];
    if (optionValue !== true) {
      updatedCookie += "=" + optionValue;
    }
  }

  document.cookie = updatedCookie;
}
